function df = effdf(ts1,ts2)
 
% function df = effdf(ts1,ts2)
% computes the effective degrees of freedom.
 
 
% The maximal lag j chosen was N/5 because it is 
% known to yield relatively accurate results in 
% terms of error rates (Pyper and Peterman, 1998).
 
ts1=ts1-mean(ts1);
ts2=ts2-mean(ts2);
N=length(ts1);

ac1=xcorr(ts1); 
ac1=ac1/max(ac1); % normalized autocorrelation
ac1=ac1(((length(ac1)+3)/2):((length(ac1)+3)/2+floor(N/5))); % lag of N/5

ac2=xcorr(ts2); 
ac2=ac2/max(ac2); % normalized autocorrelation 
ac2=ac2(((length(ac2)+3)/2):((length(ac2)+3)/2+floor(N/5))); % lag of N/5

df = 1/((1/N)+(2/N)*sum(((N-(1:length(ac1)))/N)'.*ac1.*ac2));

end