
function [out] = masterPro( sig, fs, cutU, cutL, order )

%fs = 256;
%Ts = 1/fs;
% sampling rate=256Hz in our experiment.

if nargin < 2
    error ('masterPro:warning', 'Too less input arguments')
end

if nargin < 3
    cutU = 30.0;
        cutL = 1.0;
            order = 4;
end

% Linear-phase, Low-pass filter design

cutoff= cutU;
[b,a] = butter (order, cutoff / (fs/2), 'low');
nF = ceil(9/(2*cutoff/fs)); %dirty approx of relevant impulse length
h = filter(b,a,[1 zeros(1,nF)]);   
filt = conv(h,rot90(h,2)); % a sharp lowpass filter with linear phase 

% Apply the linear-phase lowpass filter
        part=sig;
        part=conv(part,filt);
        sig1 = part(nF+1:end-nF);
clear part partM
clear F A dev b_value M Wn beta typ cutoff b a nF h filt

cutoff= cutL;
[b,a] = butter (order, cutoff / (fs/2), 'high');
nF = ceil(9/(2*cutoff/fs)); %dirty approx of relevant impulse length
h = filter(b,a,[1 zeros(1,nF)]);   
filt = conv(h,rot90(h,2)); % a sharp lowpass filter with linear phase 

% Apply the linear-phase lowpass filter
        part= sig1;
        part=conv(part,filt);
        out = part(nF+1:end-nF); 
        
%csvwrite('met2_filt.dat', met2_f_ECG);
%clear all
end