% run this script to test ECG processing and HRV analyses

load met2.csv
sig = met2(:,4); % sig has format [n, 1]
fs = 256; % original sampling rate in sig

out = masterPro(sig, fs);
[rr, ~] = rrextract(out, fs);
trr = (1/fs)*(rr-1);
td = diff(trr);
RRt = trr(2:end); % RR times (s)
RRa = td;         % RR amplitudes (s)

clear out rr trr td

[ Time, Freq ] = compParams( RRt, RRa );
% Time and Freq contain HRV parameters.
% Useage: 
% Time.mean_HR
